package asd.td7;

import asd.base.ObjetAClef;

/**
 * Une classe pour l'exercice 5 de la feuille 7.
 */
public class PresqueTrier extends asd.tri.Partition {

    /**
     * Construit un objet "presque triable" avec le tableau T.
     */
    public PresqueTrier(ObjetAClef[] T) {
        super(T);
    }

    /**
     * Teste si l'intervalle [i,j] est inclus (au sens large)
     * dans un intervalle [a,b[ o a et b sont deux multiples
     * de k conscutifs.
     */
    private boolean estInclus(int i, int j, int k) {
        return j < k * ( 1 + i / k );
    }

    /**
     * Teste si le tableau T est presque trie  l'ordre k.
     */
    public boolean presqueTrie(int k) {
        int i = 0;
        int j = 0;
        int maxPrecedent = Integer.MIN_VALUE;
        int maxCourant = Integer.MIN_VALUE;
        while ( i < T.length )
            if ( j < k ) {
                if ( T[i].clef() < maxPrecedent )
                    return false;
                if ( T[i].clef() > maxCourant )
                    maxCourant = T[i].clef();
                i++;
                j++;
            }
            else {
                maxPrecedent = maxCourant;
                maxCourant = T[i].clef();
                j = 0;
            }
        return true;
    }

    /**
     * Rend le tableau T presque trie  l'ordre k.
     * Prcondition : k > 0.
     */
    public void presqueTrier(int k) {
        presqueTrier(0,T.length-1,k);
    }

    /**
     * Rend la tranche du tableau T comprise entre les indices
     * i et j (inclus) presque trie  l'ordre k, si i < j,
     * ne fait rien sinon.
     * Prcondition : k > 0.
     */
    private void presqueTrier(int i, int j, int k) {
        if ( i < j && ! estInclus(i,j,k) ) {
            int p = partitionner(i,j);
            presqueTrier(i,p-1,k);
            presqueTrier(p+1,j,k);
        }
    }
}
