package asd.td7;

import asd.base.ObjetAClef;

/**
 * Une classe pour l'exercice 7 de la feuille 7.
 */
public class TriRapideNEP {

    private ObjetAClef[] T; // le tableau  trier

    /**
     * Construit un objet TriRapideNEP pour le tableau T.
     */
    public TriRapideNEP(ObjetAClef[] T) {
        this.T = T;
    }

    /**
     * Trie le tableau T en place suivant la mthode du "tri rapide"
     * et en utilisant un tableau annexe de taille T.length.
     * Complexit : O(n.lg(n)) o n = la taille du tableau.
     */
    public void trier() {
        ObjetAClef[] tmp = new ObjetAClef[T.length];
	trierEnPlace(T,tmp,0,T.length - 1);
    }

    /**
     * Trie A[i..j] en place en utilisant B[i..j] comme mmoire
     * temporaire.
     * Complexit : O(n.lg(n)) o n = j - i + 1.
     */
    private void trierEnPlace(ObjetAClef[] A,
                              ObjetAClef[] B,
                              int i, int j) {
	if ( i < j ) {
            int p = partitionnerDans(A,B,i,j);
            A[p] = B[p];
            trierDans(B,A,i,p-1);
            trierDans(B,A,p+1,j);
        }
    }

    /**
     * Trie A[i..j] dans B[i..j].
     * Complexit : O(n.lg(n)) o n = j - i + 1.
     */
    private void trierDans(ObjetAClef[] A,
                           ObjetAClef[] B,
                           int i, int j) {
	if ( i < j ) {
            int p = partitionnerDans(A,B,i,j);
            trierEnPlace(B,A,i,p-1);
            trierEnPlace(B,A,p+1,j);
        }
        else
            if ( i == j )
                B[i] = A[i];
    }

    /**
     * Partitionne la tranche A[i..j] dans B[i..j] et
     * retourne l'indice du pivot.
     * Prcondition : i < j.
     * Valeur rendue : p l'indice du pivot = B[p], i <= p <= j.
     * Postrelation : pour tout x dans B[i..p-1] et tout y dans B[p+1..j]
     * x < B[p] <= y.
     * Complexit : O(j-i).
     */
    private int partitionnerDans(ObjetAClef[] A,
                                 ObjetAClef[] B,
                                 int i, int j) {
        int g = i;
        int d = j;
        for ( int k = i+1; k <= j; k++ )
            if ( A[k].clef() < A[i].clef() )
                B[g++] = A[k];
            else
                B[d--] = A[k];
        B[g] = A[i]; // ou `B[d] = A[i]'
        return g;    // ou `return d'
    }
}
